//: Playground - noun: a place where people can play

import UIKit

var str = "Hello, playground"

var j = 1
print("Hello world!")
print("Hello world!\(j)")
print("\(str)!")

let pi : Double   = 3.14
var x : Double  = 100
x = x + 1

let intlist : [Int] = [1,2,3,4]

var mutableList : [Int] = [1,2,3]
mutableList.append(5);
mutableList

var intList = [Int]() // ArrayList<Int>
intList.append(1);

// Dictionary
let immutableDict = [:]
// immutableDict["a"] = 1
var mutableDict = [String:Int]()
mutableDict["a"] = 1
mutableDict["a"]

// Control flow:
if x < 2 {
    print("YEAH")
}else{
    print("WHAT?")
}

for x in 1..<10 { // python: range(1,4)
    x*x
}

// Functional Features
// Option Types
var optionX : String?
optionX = "String"
(optionX!)

if let x = optionX {
    // do something
}else{
    // throw exception
}

var optionY : String?
optionY = "SOMETHING";

if let y = optionY {
    print("Optional Y is initialized : \(y)")
}else {
    // y cannot be used here
    print("Option Y is not initialized")
}

// Tuple:
(1, "S")
(1, 0.1, "S", [String:Int]())

let tuple = (name:"Grendel", hours:102)
tuple.name
tuple.hours

// Function
class Demo {
    
    func anotherFunciton() {
        self.demoFunction1(1, param2:"A");
        self.multipleReturn().hours
        self.multipleReturn().name
    }
    
    private func demoFunction1(param1:Int, param2:String) -> Int {
        print("\(param1) and \(param2)")
        return 1
    }
    
    func multipleReturn() -> (hours:Int, name:String) {
        return (1, "A")
    }
}

let instance = Demo()
instance.anotherFunciton()

// Closure
let add1 = { (x:Int) -> Int in return (x + 1) }
let addition = { (x:Int, y:Int) -> Int in return (x+y) }
let fact = {
    (x : Int ) -> Int in
    var ret = 1;
    for i in 1..<(x+1) {
        ret *= i
    }
    return ret
}

// equivalent
func fact(x:Int) -> Int {
    var ret = 1;
    for i in 1..<(x+1) {
        ret *= i
    }
    return ret
}


fact
add1
add1(1)

// f, g => f (g x)
func composeWithX(f: (Int -> Int), g: (Int -> Int), x: Int) -> Int {
    return f (g(x));
}

// fact (add1 3) = fact (4) = 4 * 3* 2*1 = 24
composeWithX(fact, g:add1, x:3)

// f, g => return a function h = f compose g
func compose(f:(Int->Int), g:(Int->Int)) -> (Int->Int) {
    return {
        (x:Int)->Int in
        f (g(x))
    }
}

let h = compose(fact, g:add1)
h(3)



















